> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://help.sigmacomputing.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://help.sigmacomputing.com/_mcp/server.

# Create a materialization schedule for a data model element (Beta)

POST https://api.sigmacomputing.com/v2/dataModels/{dataModelId}/elements/{elementId}/materializationSchedules
Content-Type: application/json

This endpoint creates a materialization schedule for an element in a data model. The scheduled run materializes the element's data on the given cadence, allowing the data to be stored or cached for optimized access and performance.

For more details on materialization, see [Materialization](https://help.sigmacomputing.com/docs/materialization).

**Beta**: This documentation describes a public beta feature and is subject to the [Beta features](/docs/sigma-product-releases#beta-features) disclaimer.

### Usage notes

* Retrieve the **dataModelId** by calling the [/v2/dataModels](https://help.sigmacomputing.com/reference/list-data-models) endpoint.
* Retrieve the **elementId** by calling the [/v2/dataModels/\{dataModelId}/elements](https://help.sigmacomputing.com/reference/list-data-model-elements) endpoint.
* [Write access](https://help.sigmacomputing.com/docs/set-up-write-access) must be enabled on your connection.
* To perform this operation, you must use API credentials owned by a user assigned to an account type with the **Schedule materializations** permission.
* An element can have at most one materialization schedule.

Reference: https://help.sigmacomputing.com/reference/create-data-model-materialization-schedule

## Authentication

- OAuth2 — send the obtained token as `Authorization: Bearer <token>`

## Servers

- `https://api.sigmacomputing.com` (Server for GCP (US) hosted organizations, default)
- `https://api.sa.gcp.sigmacomputing.com` (Server for GCP (KSA) hosted organizations)
- `https://aws-api.sigmacomputing.com` (Server for AWS US (West) hosted organizations)
- `https://api.us-a.aws.sigmacomputing.com` (Server for AWS US (East) hosted organizations)
- `https://api.ca.aws.sigmacomputing.com` (Server for AWS Canada hosted organizations)
- `https://api.eu.aws.sigmacomputing.com` (Server for AWS Europe hosted organizations)
- `https://api.au.aws.sigmacomputing.com` (Server for AWS Australia and APAC hosted organizations)
- `https://api.uk.aws.sigmacomputing.com` (Server for AWS UK hosted organizations)
- `https://api.us.azure.sigmacomputing.com` (Server for Azure US hosted organizations)
- `https://api.eu.azure.sigmacomputing.com` (Server for Azure Europe hosted organizations)
- `https://api.ca.azure.sigmacomputing.com` (Server for Azure Canada hosted organizations)
- `https://api.uk.azure.sigmacomputing.com` (Server for Azure United Kingdom hosted organizations)
- `https://api.au.azure.sigmacomputing.com` (Server for Azure Australia hosted organizations)

## Request

### Path parameters

- `dataModelId` (string, required)
- `elementId` (string, required)

### Body (application/json)

- `schedule` (object, required) — When to run the materialization.
  - `cronSpec` (string, required) — A [cron expression](https://en.wikipedia.org/wiki/Cron). For example, `0 0 * * *`.
  - `timezone` (string, optional) — An [IANA timezone name](https://en.wikipedia.org/wiki/List_of_tz_database_time_zones). For example, `America/Los_Angeles`. Defaults to the organization timezone.

## Response

### 201

The response body.

- `sheetId` (string, required) — Identifier of the materialization schedule for the element
- `elementId` (string, required) — Identifier of the element being materialized
- `elementName` (string, required)
- `schedule` (object, required, nullable)
  - `cronSpec` (string, optional) — Cron expression to use for the schedule
  - `timezone` (string, optional) — Timezone code, for example, PST
- `configuredAt` (datetime, required)
- `paused` (boolean, required)

## Examples

**Request**

```json
{
  "schedule": {
    "cronSpec": "string"
  }
}
```

**Response**

```json
{
  "sheetId": "string",
  "elementId": "string",
  "elementName": "string",
  "schedule": {
    "cronSpec": "string",
    "timezone": "string"
  },
  "configuredAt": "2024-01-15T09:30:00Z",
  "paused": true
}
```

**SDK Code**

```python
import requests

url = "https://api.sigmacomputing.com/v2/dataModels/dataModelId/elements/elementId/materializationSchedules"

payload = { "schedule": { "cronSpec": "string" } }
headers = {
    "Authorization": "<token>.",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://api.sigmacomputing.com/v2/dataModels/dataModelId/elements/elementId/materializationSchedules';
const options = {
  method: 'POST',
  headers: {Authorization: '<token>.', 'Content-Type': 'application/json'},
  body: '{"schedule":{"cronSpec":"string"}}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.sigmacomputing.com/v2/dataModels/dataModelId/elements/elementId/materializationSchedules"

	payload := strings.NewReader("{\n  \"schedule\": {\n    \"cronSpec\": \"string\"\n  }\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Authorization", "<token>.")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.sigmacomputing.com/v2/dataModels/dataModelId/elements/elementId/materializationSchedules")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = '<token>.'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"schedule\": {\n    \"cronSpec\": \"string\"\n  }\n}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://api.sigmacomputing.com/v2/dataModels/dataModelId/elements/elementId/materializationSchedules")
  .header("Authorization", "<token>.")
  .header("Content-Type", "application/json")
  .body("{\n  \"schedule\": {\n    \"cronSpec\": \"string\"\n  }\n}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://api.sigmacomputing.com/v2/dataModels/dataModelId/elements/elementId/materializationSchedules', [
  'body' => '{
  "schedule": {
    "cronSpec": "string"
  }
}',
  'headers' => [
    'Authorization' => '<token>.',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://api.sigmacomputing.com/v2/dataModels/dataModelId/elements/elementId/materializationSchedules");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "<token>.");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"schedule\": {\n    \"cronSpec\": \"string\"\n  }\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "Authorization": "<token>.",
  "Content-Type": "application/json"
]
let parameters = ["schedule": ["cronSpec": "string"]] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.sigmacomputing.com/v2/dataModels/dataModelId/elements/elementId/materializationSchedules")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```